Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class DateValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.CalendarValue
                  net.sf.saxon.value.GDateValue
                      net.sf.saxon.value.DateValue

All Implemented Interfaces:
  Serializable, Comparable, SequenceIterable, Item, ValueRepresentation

    public class DateValue

extends GDateValue

A value of type Date. Note that a Date may include a TimeZone.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.value.CalendarValue
`NO_TIMEZONE`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`DateValue(CharSequence s)` Constructor: create a dateTime value from a supplied string, in ISO 8601 format
`DateValue(GregorianCalendar calendar, int tz)` Create a DateValue
`DateValue(int year, byte month, byte day)` Constructor given a year, month, and day.
`DateValue(int year, byte month, byte day, int tz)` Constructor given a year, month, and day, and timezone.
`DateValue(int year, byte month, byte day, int tz, AtomicType type)` Constructor given a year, month, and day, and timezone, and an AtomicType representing a subtype of xs:date.

Method Summary
`CalendarValue` | `add(DurationValue duration)` Add a duration to a date
`CalendarValue` | `adjustTimezone(int timezone)` Return a new date with the same normalized value, but in a different timezone.
`AtomicValue` | `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`AtomicValue` | `copy(AtomicType typeLabel)` Make a copy of this date, time, or dateTime value
`static DateValue` | `dateFromJulianDayNumber(int julianDayNumber)` Get the Gregorian date corresponding to a particular Julian day number.
`AtomicValue` | `getComponent(int component)` Get a component of the value.
`static int` | `getDayOfWeek(int year, int month, int day)` Get the day of the week.
`static int` | `getDayWithinYear(int year, int month, int day)` Get the ordinal day number within the year (1 Jan = 1, 1 Feb = 32, etc)
`static int` | `getJulianDayNumber(int year, int month, int day)` Calculate the Julian day number at 00:00 on a given date.
`BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
`CharSequence` | `getStringValueCS()` Convert to string
`static int` | `getWeekNumber(int year, int month, int day)` Get the ISO week number for a given date.
`static int` | `getWeekNumberWithinMonth(int year, int month, int day)` Get the week number within a month.
`Comparable` | `getXPathComparable()` Get a Comparable value that implements the XPath ordering comparison semantics for this value.
`static void` | `main(String[] args)` Temporary test rig
`DayTimeDurationValue` | `subtract(CalendarValue other, XPathContext context)` Determine the difference between two points in time, as a duration
`static DateValue` | `tomorrow(int year, byte month, byte day)` Get the date that immediately follows a given date
`static DateValue` | `yesterday(int year, byte month, byte day)` Get the date that immediately precedes a given date

Methods inherited from class net.sf.saxon.value.GDateValue
`compareTo, compareTo, convertToJava, equals, getCalendar, getComparisonKey, getDay, getMonth, getYear, hashCode, isLeapYear, isValidDate, setLexicalValue, toDateTime`

Methods inherited from class net.sf.saxon.value.CalendarValue
`adjustTimezone, appendTimezone, appendTimezone, getStringValue, getTimezoneInMinutes, hasTimezone, removeTimezone, setTimezoneInMinutes`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, effectiveBooleanValue, getCardinality, getItemType, getLength, getTypedValue, getTypeLabel, hasBuiltInType, isMultiValued, itemAt, iterate, process, setTypeLabel, toString`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convert, convertJavaObjectToXPath, fromItem, getCanonicalLexicalRepresentation, getIterator, getSchemaComparable, iterate, makeQNameValue, reduce, stringToNumber`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DateValue

    public DateValue(int year,
                     byte month,
                     byte day)

  Constructor given a year, month, and day. Performs no validation.

  Parameters:
    `year` - The year as held internally (note that the year before 1AD is 0)
    `month` - The month, 1-12
    `day` - The day 1-31

### DateValue

    public DateValue(int year,
                     byte month,
                     byte day,
                     int tz)

  Constructor given a year, month, and day, and timezone. Performs no validation.

  Parameters:
    `year` - The year as held internally (note that the year before 1AD is 0)
    `month` - The month, 1-12
    `day` - The day 1-31
    `tz` - the timezone displacement in minutes from UTC. Supply the value `CalendarValue.NO_TIMEZONE` if there is no timezone component.

### DateValue

    public DateValue(int year,
                     byte month,
                     byte day,
                     int tz,
                     AtomicType type)

  Constructor given a year, month, and day, and timezone, and an AtomicType representing a subtype of xs:date. Performs no validation.

  Parameters:
    `year` - The year as held internally (note that the year before 1AD is 0)
    `month` - The month, 1-12
    `day` - The day 1-31
    `tz` - the timezone displacement in minutes from UTC. Supply the value `CalendarValue.NO_TIMEZONE` if there is no timezone component.
    `type` - the type. This must be a type derived from xs:date, and the value must conform to this type. The method does not check these conditions.

### DateValue

    public DateValue(CharSequence s)
              throws XPathException

  Constructor: create a dateTime value from a supplied string, in ISO 8601 format

  Throws:
    `XPathException`

### DateValue

    public DateValue(GregorianCalendar calendar,
                     int tz)

  Create a DateValue

  Parameters:
    `calendar` - the absolute date/time value
    `tz` - The timezone offset from GMT in minutes, positive or negative; or the special value NO_TIMEZONE indicating that the value is not in a timezone

Method Detail

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Specified by:
    `getPrimitiveType` in class `AtomicValue`

### tomorrow

    public static DateValue tomorrow(int year,
                                     byte month,
                                     byte day)

  Get the date that immediately follows a given date

  Returns:
    a new DateValue with no timezone information

### yesterday

    public static DateValue yesterday(int year,
                                      byte month,
                                      byte day)

  Get the date that immediately precedes a given date

  Returns:
    a new DateValue with no timezone information

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Specified by:
    `convertPrimitive` in class `AtomicValue`
  Parameters:
    `requiredType` - an integer identifying the required atomic type
    `context` -
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    an AtomicValue, a value of the required type; or an ErrorValue

### getStringValueCS

    public CharSequence getStringValueCS()

  Convert to string

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Overrides:
    `getStringValueCS` in class `AtomicValue`
  Returns:
    ISO 8601 representation.
  See Also:
    `Item.getStringValue()`

### copy

    public AtomicValue copy(AtomicType typeLabel)

  Make a copy of this date, time, or dateTime value

  Specified by:
    `copy` in class `AtomicValue`
  Parameters:
    `typeLabel` -

### adjustTimezone

    public CalendarValue adjustTimezone(int timezone)

  Return a new date with the same normalized value, but in a different timezone. This is called only for a DateValue that has an explicit timezone

  Specified by:
    `adjustTimezone` in class `CalendarValue`
  Parameters:
    `timezone` - the new timezone offset, in minutes
  Returns:
    the time in the new timezone. This will be a new TimeValue unless no change was required to the original value

### getComponent

    public AtomicValue getComponent(int component)
                             throws XPathException

  Get a component of the value. Returns null if the timezone component is requested and is not present.

  Overrides:
    `getComponent` in class `AtomicValue`
  Throws:
    `XPathException`

### add

    public CalendarValue add(DurationValue duration)
                      throws XPathException

  Add a duration to a date

  Specified by:
    `add` in class `CalendarValue`
  Parameters:
    `duration` - the duration to be added (may be negative)
  Returns:
    the new date
  Throws:
    `XPathException` - if the duration is an xs:duration, as distinct from a subclass thereof

### subtract

    public DayTimeDurationValue subtract(CalendarValue other,
                                         XPathContext context)
                                  throws XPathException

  Determine the difference between two points in time, as a duration

  Overrides:
    `subtract` in class `CalendarValue`
  Parameters:
    `other` - the other point in time
    `context` -
  Returns:
    the duration as an xs:dayTimeDuration
  Throws:
    `XPathException` - for example if one value is a date and the other is a time

### getJulianDayNumber

    public static int getJulianDayNumber(int year,
                                         int month,
                                         int day)

  Calculate the Julian day number at 00:00 on a given date. This algorithm is taken from http://vsg.cape.com/~pbaum/date/jdalg.htm and http://vsg.cape.com/~pbaum/date/jdalg2.htm (adjusted to handle BC dates correctly)

### dateFromJulianDayNumber

    public static DateValue dateFromJulianDayNumber(int julianDayNumber)

  Get the Gregorian date corresponding to a particular Julian day number. The algorithm is taken from http://www.hermetic.ch/cal_stud/jdn.htm#comp

  Returns:
    a DateValue with no timezone information set

### getDayWithinYear

    public static final int getDayWithinYear(int year,
                                             int month,
                                             int day)

  Get the ordinal day number within the year (1 Jan = 1, 1 Feb = 32, etc)

### getDayOfWeek

    public static final int getDayOfWeek(int year,
                                         int month,
                                         int day)

  Get the day of the week. The days of the week are numbered from 1 (Monday) to 7 (Sunday)

### getWeekNumber

    public static final int getWeekNumber(int year,
                                          int month,
                                          int day)

  Get the ISO week number for a given date. The days of the week are numbered from 1 (Monday) to 7 (Sunday), and week 1 in any calendar year is the week (from Monday to Sunday) that includes the first Thursday of that year

### getWeekNumberWithinMonth

    public static final int getWeekNumberWithinMonth(int year,
                                                     int month,
                                                     int day)

  Get the week number within a month. This is required for the XSLT format-date() function, and the rules are not entirely clear. The days of the week are numbered from 1 (Monday) to 7 (Sunday), and by analogy with the ISO week number, we consider that week 1 in any calendar month is the week (from Monday to Sunday) that includes the first Thursday of that month. Unlike the ISO week number, we put the previous days in week zero.

### getXPathComparable

    public Comparable getXPathComparable()

  Get a Comparable value that implements the XPath ordering comparison semantics for this value. Returns null if the value is not comparable according to XPath rules. The default implementation returns null. This is overridden for types that allow ordered comparisons in XPath: numeric, boolean, string, date, time, dateTime, yearMonthDuration, dayTimeDuration, and anyURI.

  Overrides:
    `getXPathComparable` in class `AtomicValue`

### main

    public static void main(String[] args)
                     throws Exception

  Temporary test rig

  Throws:
    `Exception`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.